<template>
  <div v-if="games.length" class="swiper">
    <swiper
      :modules="modules"
      :slides-per-view="games[0].SlidesPerView"
      :navigation="games.length > games[0].SlidesPerView"
      class="swiper-wrapper max-w-[1200px]"
    >
      <swiper-slide
        v-for="game in games"
        :key="game.GameId"
        class="swiper-slide"
        :class="
          game.CategoryType === 'isSport' ? 'max-w-[400px]' : 'max-w-[239.19px]'
        "
      >
        <section v-if="game.CategoryType === 'isSport'">
          <nuxt-link
            :to="auth ? `/Game/${game.GameId}${tabTypeForRoute}` : '/login'"
            class="flex"
          >
            <img
              :src="game.GameImageForDisplay"
              class="w-[200px] h-auto mb-[5px] hover:duration-500 hover:scale-110 mr-[12px]"
              loading="lazy"
            />
            <div class="flex flex-col justify-center">
              <div class="flex flex-row items-center logo-tags gap-2 pb-3 china-btn__tag">
                <img
                  v-if="game.IsNewGameProvider"
                  :src="
                    getAssetImage(
                      'assets/theme/common/icon/new_icon.svg'
                    )
                  "
                />
                <img
                  v-if="game.IsHotGameProvider"
                  :src="
                    getAssetImage(
                      'assets/theme/common/icon/hot_icon.svg'
                    )
                  "
                />
              </div>
              <div class="flex items-center mb-[15px]">
                <div class="product-hover-logo-bg">
                  <img
                    :src="game.IconForDisplay"
                    class="w-[32px] h-[32px]"
                    loading="lazy"
                  />
                </div>
                <div class="ml-[5px] flex flex-col items-start leading-none">
                  <div class="font-semibold text-[18px] mb-[4px] break-words min-w-[120px] w-fit">
                    {{ game.GameProviderDisplayName }}
                  </div>
                  <div class="whitespace-nowrap text-[12px]">
                    {{ game.EnglishGameName }}
                  </div>
                </div>
              </div>
              <button
                class="sport-entry-play-button"
                :style="`--btnActiveBg: ${btnActiveBg};`"
              >
                {{ $t("play_now") }}
              </button>
            </div>
          </nuxt-link>
        </section>
        <section v-else class="flex flex-col items-center relative">
          <div class="flex flex-col items-center relative">
            <div
              class="cursor-pointer"
              :class="
                game.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
              "
              @click="handleRedirectRoute(game)"
            >
              <div class="flex flex-row items-center logo-tags gap-2 pb-3 china-btn__tag" v-if="game.IsNewGameProvider || game.IsHotGameProvider">
                <img
                  v-if="game.IsNewGameProvider"
                  :src="
                    getAssetImage(
                      'assets/theme/common/icon/new_icon.svg'
                    )
                  "
                />
                <img
                  v-if="game.IsHotGameProvider"
                  :src="
                    getAssetImage(
                      'assets/theme/common/icon/hot_icon.svg'
                    )
                  "
                />
              </div>
              <div class="flex items-center mb-[15px]">
                <div class="product-hover-logo-bg">
                  <img
                    class="w-[32px] h-[32px]"
                    :src="game.GameLogoForDisplay"
                    alt=""
                    loading="lazy"
                  />
                </div>
                <div class="ml-[5px] flex flex-col items-start leading-none">
                  <div class="font-semibold text-[18px] mb-[4px]">
                    {{ game.GameProviderDisplayName }}
                  </div>
                  <div class="text-[12px]">
                    {{
                      game.TabType !== "Lottery"
                        ? $t(game.GameProviderName)
                        : game.EnglishGameName
                    }}
                  </div>
                </div>
              </div>
              <div
                v-if="game.IsMaintain"
                class="absolute w-12 h-12 top-[120px] left-[46px] z-[2]"
              >
                <img
                  :src="
                    getAssetImage(
                      'assets/theme/common/icon/icon_maintainance.png'
                    )
                  "
                  alt=""
                />
              </div>
              <div
                class="w-[150px] h-[150px] hover:duration-500 hover:scale-110"
              >
                <img
                  class="pb-[10px] h-[150px]"
                  :src="game.GameImageForDisplay"
                  alt=""
                  loading="lazy"
                />
              </div>
            </div>
          </div>
        </section>
      </swiper-slide>
    </swiper>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType } from "vue";
import { Navigation } from "swiper";
import { GameBsi } from "@/models/bsiGameList";
import { store } from "@/store";
import { IGame } from "@/models/IGetPlayableGamesResponse";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";

export default defineComponent({
  props: {
    games: {
      type: Array as PropType<Array<GameBsi>>,
      required: true,
      default: () => [],
    },
  },
  emits: ["update:isFeatureContentEnabled"],
  setup(props) {
    const tabTypeForRoute = computed(() => {
      let result = "";
      props.games.forEach((item) => {
        if (item !== undefined) {
          result = item.TabType.replaceAll(" ", "-").toLowerCase();
        }
      });
      return result === ""
        ? `?entrance=${EnumEntranceLocation.Hover}`
        : `?tab=${result}&entrance=${EnumEntranceLocation.Hover}`;
    });
    const router = useRouter();
    const auth = store.state.auth;
    const handleRedirectRoute = (game: IGame) => {
      if (auth) {
        if (game.CategoryName !== "GAMES") {
          commonHelper.handlePopupNewWindow(
            `game/${game.GameId}${tabTypeForRoute.value}`,
            850,
            850
          );
        } else {
          router.push(`/games/${game.GameProviderName}__n__gp`);
        }
      } else {
        router.push("/login");
      }
    };
    const { getAssetImage } = commonHelper;
    const btnActiveBg = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/btn-background-active.png"
    )})`;
    return {
      auth,
      handleRedirectRoute,
      modules: [Navigation],
      tabTypeForRoute,
      btnActiveBg,
      getAssetImage,
    };
  },
});
</script>

<style scoped lang="scss">
.product-hover-logo-bg {
  background: linear-gradient(
    180deg,
    rgba(254, 254, 255, 1) 0%,
    rgba(249, 250, 254, 1) 30%,
    rgba(238, 241, 253, 1) 70%,
    rgba(233, 237, 252, 1) 100%
  );
  box-shadow: 0 5px 10px 0 rgba(112, 146, 215, 0.14);
  transition: 0.3s ease-in-out;
  border-radius: 13px;
  display: flex;
  justify-content: center;
  align-items: center;
  border-bottom: 3px solid #fff;
  width: 50px;
  height: 50px;
}
.sport-entry-play-button {
  background-image: var(--btnActiveBg);
  background-size: cover;
  min-width: 120px;
  width: fit-content;
  height: 35px;
  color: white;
  cursor: pointer;
  transition: 0.3s ease-in-out;
  border-radius: 30px;
  padding: 0 10px;
}

.sport-entry-play-button:hover {
  transform: scale(1.1);
}
.china-btn__tag {
  width: 50px;
  // height: 20px;
}
</style>
